﻿//by:zhouxiang 
//Home:zhouxiang.decadework.com 
//Time:2015年10月7日
//Desc:程序核心
(function (W, $) {
    'use strict';
    //common
    var myAppPlus = {
        //验证码计时器
        sendcode_num: function (IsOne) {
            if (IsOne) {
                $("span.codesms").text("60").prop("disabled", true);
            }
            setTimeout(function () {
                var num = parseInt($("span.codesms").text()) - 1;
                if (num > 0) {
                    $("span.codesms").text(num);
                    myAppPlus.sendcode_num(false);
                } else {
                    $("span.codesms").text("获取验证码").prop("disabled", false);
                }
            }, 1000);
        },
        //发送验证码
        sendcode: function ($scope, Common) {
            var phone = $scope.phone || '';
            if ($("span.codesms").text() != "获取验证码") {
                return;
            }
            if (phone == "") {
                Common.Alert("手机号不能为空");
                return;
            }
            if (phone.length != 11) {
                Common.Alert("手机号长度错误");
                return;
            }
            myAppPlus.sendcode_num(true);
            Common.post({ action: 'w_code', json: { phone: phone } }, function (data) {
                Common.Alert("发送成功");
            });
        },
        //根据停车场ID获取停车场名字
        GetParkName: function (_parkID, Common) {
            var parkArr = $.parseJSON(Common.localData.get('park'));
            for (var i = 0; i < parkArr.length; i++) {
                var park = parkArr[i];
                if (park != null && park != undefined && park.parkId != null && park.parkId == _parkID) {
                    return park.parkName;
                }
            }
            return "";
        }
    };
    //myapp
    angular.module('myApp', ['ui.router', 'myApp.controllers', 'myApp.services'])
	.config(function ($stateProvider, $urlRouterProvider) {
	    $urlRouterProvider.when("", "/login");
	    $stateProvider
             // 导航
            .state("nav", {
                cache: false,
                url: "/nav",
                templateUrl: "/template/default/nav.html",
                controller: 'navCtrl'
            })
            //解锁
            .state("lock", {
                cache: false,
                url: "/lock",
                templateUrl: "/template/default/lock.html",
                controller: 'lockCtrl'
            })
              // 停车计费
            .state("paysuan", {
                cache: false,
                url: "/paysuan",
                templateUrl: "/template/default/paysuan.html",
                controller: 'paysuanCtrl'
            })
             // 交易查询
            .state("paysearch", {
                cache: false,
                url: "/paysearch",
                templateUrl: "/template/default/paysearch.html",
                controller: 'paysearchCtrl'
            })
             // 支付页面
            .state("pay", {
                cache: false,
                url: "/pay",
                templateUrl: "/template/default/pay.html",
                controller: 'payCtrl'
            })
             // 云停车
            .state("yuncar", {
                cache: false,
                url: "/yuncar",
                templateUrl: "/template/default/yuncar.html",
                controller: 'yuncarCtrl'
            })
            // 登录
            .state("login", {
                cache: false,
                url: "/login",
                templateUrl: "/template/default/login.html",
                controller: 'loginCtrl'
            })
            //注册
	        .state("register", {
	            cache: false,
	            url: "/register",
	            templateUrl: "/template/default/register.html",
	            controller: 'registerCtrl'
	        })
            //找回密码
	        .state("retpass", {
	            cache: false,
	            url: "/retpass",
	            templateUrl: "/template/default/retpass.html",
	            controller: 'retpassCtrl'
	        })
	        //帐户充值
	        .state("accountpay", {
	            cache: false,
	            url: "/accountpay",
	            templateUrl: "/template/default/accountpay.html",
	            controller: 'accountpayCtrl'
	        })
            //我的钱包
	        .state("myaccount", {
	            cache: false,
	            url: "/myaccount",
	            templateUrl: "/template/default/myaccount.html",
	            controller: 'myaccountCtrl'
	        });
	});
    //控制器
    angular.module('myApp.controllers', [])
    .controller('lockCtrl', function ($scope, Common) {
        //添加编辑方法
        var addoreditjiesuo = function (obj) {
            //显示内容  绑定保存事件
        }
        //删除方法
        var deljiesuo = function (id) {
            //提示是否删除
        }
        //查询解锁设置 
        Common.post({ action: 'w_unlockTimeHtml', json: {} }, function (data) {
            //获取数据后 处理数据
            if (data.length > 0) {
                var arrData = new Array();
                for (var i = 0; i < data.length; i++) {
                    //var 
                }
                $scope.payLogData = paylog.list;
            }
        });
        //绑定添加时段点击事件
        $("#addshidang").click(function () {

        });
    })
    .controller('paysuanCtrl', function ($scope, Common) {
        //获取当前缓存里的车牌号码 
        $("#chepaihao").text(Common.localData.get("phone"));
        //查询停车时间 停车时长 停车场ID（根据ID转化成中文）
        Common.post({ action: 'w_parkingPay', json: {} }, function (data) {
            //获取信息
            var tingche = $.parseJSON(data);
            $("#tingchechangname").text(myAppPlus.GetParkName(tingche.parkId, Common));
            $("#inTime").text(tingche.inTime);
            $("#stopTime").text(tingche.stopTime);
        });
        $scope.clickPaySuan = function () {
            //查询停车费用
            Common.post({ action: 'w_payCount', json: { parkId: Common.localData.get("parkId"), carPlate: Common.localData.get("phone") } }, function (data) {
                //得到费用
                $("span.yu").text(data);
            });
        }
        $scope.clickPaySuan();
        $scope.clickPay = function () {
            Common.localData.set("ordertype", 2);
            location.href = "/#/pay";
        }
    })
    .controller('paysearchCtrl', function ($scope, Common) {
        //构造分页方法
        var PageHtml = function (PageIndex, PageCount) {
            var PageHtml = "";
            var PageNum = 10;
            if (PageCount > PageNum) {
                var PageNumber = PageCount / PageNum;
                PageNumber += (PageCount % PageNum) > 0 ? 1 : 0;
                var ForNumber = PageNumber > 4 ? 4 : PageNumber;
                var StartPage = PageIndex > 2 ? PageIndex - 2 : 0;
                if (PageIndex > 0) {
                    PageHtml += "<li index=\"" + ((PageIndex - 1) <= 0 ? 1 : (PageIndex - 1)) + "\"></li>";
                }
                for (var i = 1; i <= ForNumber; i++) {
                    if ((StartPage + i) > PageNumber) break;
                    if ((StartPage + i) == PageIndex) {
                        PageHtml += "<li class=\"hover\">" + PageIndex + "</li>";
                    }
                    else {
                        PageHtml += "<li index=\"" + (StartPage + i) + "\">" + (StartPage + i) + "</li>";
                    }
                }
                PageHtml += "<li index=\"" + ((PageIndex + 1) > PageNumber ? PageNumber : (PageIndex + 1)) + "\"></li>";

            }
            if (PageHtml == "")
            { }
            return PageHtml;
        }
        //交易查询 多次返回 
        var search_paylog = function (_pageindex) {
            Common.post({ action: 'w_list', json: { num: _pageindex } }, function (data) {
                var paylog = $.parseJSON(data);
                //重新绑定界面
                $scope.payLogData = paylog.list;
                //重新构造分页
                $("div.pagefy ul").html(PageHtml(_pageindex, paylog.totalCount));
                $("div.pagefy li").click(function () {
                    var index = parseInt($(this).attr("index"));
                    search_paylog(index);
                });
            });
        }
        //加载第一页数据
        search_paylog(1);
    })
     .controller('payCtrl', function ($scope, Common) {
         var _ordertype = 0;//0停车缴费 1钱包充值
         var _orderprice = 0;
         var paytype = 0;//0钱包支付 1微信支付
         var _paymoney = 0;
            var _orderno = "";
         if (Common.localData.get("ordertype") == "1") {
             _ordertype = 1;
             paytype = 1;
             _orderprice = Common.localData.get("orderprice");
             //钱包充值 添加订单
             Common.post({ action: 'w_recharge', json: { money: _orderprice } }, function (data) {
                 $("#tingchechangname").text("钱包充值");
                 $("#inTime").parent().remove();
                 $("#stopTime").parent().remove();
                 $("#orderNo").text(data);
                 $("#chepaihao").parent().remove();
                 $("#ordername").text("充值");
                 _paymoney = parseInt(_orderprice);
                 $("#paymoney").text("￥" + _orderprice + ".00");
                 _orderno = data;
             });
         } else {
             //缴费停车 添加订单
             Common.post({ action: 'w_payHtml', json: { parkId: Common.localData.get("parkId"), carPlate: Common.localData.get("phone") } }, function (data) {
                 var tingche = $.parseJSON(data);
                 $("#tingchechangname").text(myAppPlus.GetParkName(tingche.parkId, Common));
                 $("#inTime").text(tingche.inTime);
                 $("#stopTime").text(tingche.stopTime);
                 $("#orderNo").text(tingche.orderNumber);
                 _paymoney = parseInt(tingche.fee);
                 _orderno = tingche.orderNumber;
                 $("#paymoney").text("￥" + tingche.fee + ".00");
             });
         }
         //如果当前是钱包充值的时候 去掉钱包支付
         if (_ordertype == 1) {
             $("li[name=payfs]").eq(0).remove();
         }
         //绑定支付方式选择事件
         $("li[name=payfs]").click(function () {
             $("span.rightG").removeClass("rightGhover");
             $(this).find("span.rightG").addClass("rightGhover");
             paytype = parseInt($(this).attr("index"));
         });
         $scope.clickPay = function () {
             if (paytype == 1) {
                 //调用微信支付
                 $("div.btn").text("正在请求,请稍候...");
                 //钱包支付 直接调用接口 只有缴费停车才能使用
                 Common.post({ action: "wxpayconfig", json: {}, tenpay: _paymoney, shopdesc: "车易泊费用", sp_billno: _orderno }, function (data) {
                     //如果微信下单成功 则调用微信支付
                     WeixinJSBridge.invoke('getBrandWCPayRequest', {
                         "appId": data.appid, //公众号名称，由商户传入
                         "timeStamp": data.timeStamp, //时间戳
                         "nonceStr": data.nonceStr, //随机串
                         "package": data.package, //扩展包
                         "signType": "MD5", //微信签名方式:1.sha1
                         "paySign": data.paySign //微信签名
                     }, function (res) {
                         if (res.err_msg == "get_brand_wcpay_request:ok") {
                             //成功后 不做同步处理 直接弹出层 因有异步自动处理
                             $("div.panltsqp").show();
                             $("div.panlts").show();
                         } else if (res.err_msg == "get_brand_wcpay_request:cancel") {
                             Common.Alert("用户取消支付!");
                         } else {
                             Common.Alert("支付失败!");
                         }
                     });
                 });
             } else {
                 //钱包支付 直接调用接口 只有缴费停车才能使用
                 Common.post({ action: "w_pay", json: { orderNumber: $("#orderNo").text() } }, function (data) {
                     //判定是否支付成功
                     $("div.panltsqp").show();
                     $("div.panlts").show();
                 });
             }
         }
     })
     .controller('yuncarCtrl', function ($scope, Common) {
         //根据云锁车接口获取数据
         Common.post({ action: 'w_unlock', json: {} }, function (data) {
             var yuncar = $.parseJSON(data);
             //缓存当前停车场ID
             Common.localData.set('parkId', yuncar.parkId);
             //获取是否锁车状态
             if (yuncar.lockStatus == 0 || yuncar.lockStatus == 2) {
                 //有一个图标更换的问题 先不管
                 $("div.suoche span").removeClass("hover");
                 $("span.state").text("已锁车");
                 $("div.suoche span").eq(1).addClass("hover");
                 $("div.suoche span").eq(1).find("img").attr("src", "/images/yuncar/yun21.png");
                 $("div.suoche span").eq(0).find("img").attr("src", "/images/yuncar/yun11.png");
             }
             //获取解锁时段及停车场 需更改 
             var lockTime = yuncar.lockTime.toString().replace("\\\/", ":").split(",");
             var lockTimeStatus = yuncar.lockTimeStatus.split(",");
         });
         $("span.chepai").text(Common.localData.get("phone"));
         $scope.settingcartime = function () {
             location.href = "/#/lock";
         }
         //绑定手动解锁和锁定事件
         $("div.suoche span").click(function () {
             $("div.suoche span").removeClass("hover");
             $(this).addClass("hover");
             //手动锁车接口
             var _action = "w_manuallyLock";
             var _index = $(this).index();
             if ($(this).index() == 0) {
                 //手动解锁接口
                 _action = "w_manuallyUnlock";
             }
             //发送Action
             Common.post({ action: _action, json: { parkId: Common.localData.get("parkId") } }, function (data) {

                 if (_index == 0) {
                     $("span.state").text("未锁车");
                     $("div.suoche span").eq(1).find("img").attr("src", "/images/yuncar/yun2.png");
                     $("div.suoche span").eq(0).find("img").attr("src", "/images/yuncar/yun1.png");
                 } else {
                     $("div.suoche span").eq(1).find("img").attr("src", "/images/yuncar/yun21.png");
                     $("div.suoche span").eq(0).find("img").attr("src", "/images/yuncar/yun11.png");
                     $("span.state").text("已锁车");
                 }
                 Common.Alert("操作成功");
             });
         });
     })
    .controller('navCtrl', function ($scope, Common) {
        //用于处理微信打开的登录问题
        //获取系统缓存OPENID 进行登录
        Common.post({ action: "GetOpenid", json: {} }, function (openid) {
            if (openid != "") {
                //登录
                Common.post({ action: 'w_openid', json: { openid: openid } }, function (data) {
                    if (data.length > 0) {
                        var login = data[0];
                        //缓存当前登录车牌号
                        Common.localData.set('phone', phone);
                        //缓存KEY
                        Common.localData.set('key', login.key);
                        //如果有返回停车场 则缓存起来
                        if (login.park.length > 0) {
                            //缓存登陆信息
                            Common.localData.set('park', JSON.stringify(login.park));
                        }
                        //成功则跳转到来源页面
                        location.href = document.referrer;
                    } else {
                        location.href = "/#/login";
                    }
                });
            } else {
                location.href = "/#/login";
            }
        });
    })
    .controller('loginCtrl', function ($scope, Common) {
        var _openid = "";
        Common.post({ action: "GetOpenid", json: {} }, function (openid) {
            if (openid != "") {
                _openid = openid;
            }
        });
        $scope.login = function () {
            var phone = $scope.phone || '',
                pass = $scope.pass || '';
            if (phone == "") {
                Common.Alert("请输车牌号");
                return;
            }
            if (pass == "") {
                Common.Alert("请输入密码");
                return;
            }
            //登录
            Common.post({ action: 'w_login', json: { account: phone, password: pass, openid: _openid } }, function (data) {
                var login = data[0];
                //缓存当前登录车牌号
                Common.localData.set('phone', phone);
                //缓存KEY
                Common.localData.set('key', login.key);
                //如果有返回停车场 则缓存起来
                if (login.park.length > 0) {
                    //缓存登陆信息
                    Common.localData.set('park', JSON.stringify(login.park));
                }
                //成功则跳转到到云锁车
                location.href = "/#/yuncar";
            });
        }
    })
    .controller('registerCtrl', function ($scope, Common) {
        $scope.sendcode = function () {
            myAppPlus.sendcode($scope, Common);
        }
        $scope.reg = function () {
            var phone = $scope.phone || '',
                code = $scope.code || '',
                cartxt = $scope.cartxt || '',
                carselect = $scope.carselect || '',
                pass = $scope.pass || '';
            if (phone == "") {
                Common.Alert("手机号不能为空");
                return;
            }
            if (phone.length != 11) {
                Common.Alert("手机号长度错误");
                return;
            }
            if (code == "") {
                Common.Alert("验证码不能为空");
                return;
            }
            if (pass == "") {
                Common.Alert("密码不能为空");
                return;
            }
            if (cartxt == "") {
                Common.Alert("车牌号不能为空");
                return;
            }
            Common.post({ action: 'w_register', json: { account: carselect + cartxt, password: pass, phone: phone, securityCode: code } }, function (data) {
                //注册成功后 回到登陆页面
                location.href = "/#/login";
            });
        }
    })
    .controller('retpassCtrl', function ($scope, Common) {
        $scope.sendcode = function () {
            myAppPlus.sendcode($scope, Common);
        }
        $scope.uppass = function () {
            var phone = $scope.phone || '',
                code = $scope.code || '',
                cartxt = $scope.cartxt || '',
                carselect = $scope.carselect || '',
                pass = $scope.pass || '';
            if (phone == "") {
                Common.Alert("手机号不能为空");
                return;
            }
            if (phone.length != 11) {
                Common.Alert("手机号长度错误");
                return;
            }
            if (code == "") {
                Common.Alert("验证码不能为空");
                return;
            }
            if (pass == "") {
                Common.Alert("密码不能为空");
                return;
            }
            if (cartxt == "") {
                Common.Alert("车牌号不能为空");
                return;
            }
            Common.post({ action: 'w_pwd', json: { account: carselect + cartxt, password: pass, phone: phone, securityCode: code } }, function (data) {
                //找回密码成功后 回到登陆页面
                location.href = "/#/login";
            });
        }
    })
    .controller('accountpayCtrl', function ($scope, Common) {
        $scope.paysub = function () {
            var pay = $scope.pay || '';
            if (pay == "") {
                Common.Alert("请输入充值金额");
                return;
            }
            if (!parseInt(pay)) {
                Common.Alert("充值金额格式错误");
                return;
            }
            Common.localData.set("ordertype", 1);
            Common.localData.set("orderprice", pay);
            //转向支付页面
            location.href = "/#/pay";
        }
    })
    .controller('myaccountCtrl', function ($scope, Common) {
        Common.post({ action: 'w_wallet', json: {} }, function (data) {
            //获取钱包余额
            $("#paymoney").text(data);
        });
    });
    //数据处理
    angular.module('myApp.services', [])
    .factory('Common', function ($http, $location) {
        var subUrl = '/ashx/WEBAPI.ashx';
        var $return = {
            localData: {
                get: function (name) {
                    return window.localStorage.getItem(name);
                },
                set: function (name, val) {
                    window.localStorage.setItem(name, val);
                },
                remove: function (name) {
                    delete window.localStorage.name;
                }
            },
            Alert: function (msg) {
                alert(msg);
            },
            post: function (data, success, error) {
                data = data instanceof Object && data || {};
                if ($return.localData.get('key') != null) {
                    data.json.key = $return.localData.get('key');
                }
                data = JSON.stringify(data);
                $http.post(subUrl, data, { timeout: 10000 })
                  .success(function (data, status, headers, config) {
                      switch (data.result) {
                          case "success":
                              success instanceof Function && success(data.data);
                              break;
                          case "error":
                              if (data && data.code && parseInt(data.code) == 400) {
                                  //标识为未登录 清除KEY 转向自动处理页面
                                  $return.localData.remove('key');
                                  location.href = "/#/nav";
                              }
                              if (data && data.info) {
                                  $return.Alert(data.info);
                              }
                              error instanceof Function && error(data.info);
                              break;
                      }
                  }).error(function (data, result, headers, config) { });
            }
        };
        return $return;
    });
})(window, Zepto);