﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Xml;
using WeiXinPay;

public partial class pay_Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            StreamReader reader = new StreamReader(Request.InputStream);
            String xmlData = reader.ReadToEnd();
            var xdoc = new XmlDocument();
            xdoc.LoadXml(xmlData);
            XmlNode xn = xdoc.SelectSingleNode("xml");
            XmlNodeList xnl = xn.ChildNodes;

            if (xnl.Count == 16)
            {
                var packageReqHandler = new RequestHandler(Context);
                packageReqHandler.init();
                packageReqHandler.setParameter("appid", xnl[0].InnerText);
                packageReqHandler.setParameter("bank_type", xnl[1].InnerText);
                packageReqHandler.setParameter("cash_fee", xnl[2].InnerText);
                packageReqHandler.setParameter("fee_type", xnl[3].InnerText);
                packageReqHandler.setParameter("is_subscribe", xnl[4].InnerText);
                packageReqHandler.setParameter("mch_id", xnl[5].InnerText);
                packageReqHandler.setParameter("nonce_str", xnl[6].InnerText);
                packageReqHandler.setParameter("openid", xnl[7].InnerText);
                packageReqHandler.setParameter("out_trade_no", xnl[8].InnerText);
                packageReqHandler.setParameter("result_code", xnl[9].InnerText);
                packageReqHandler.setParameter("return_code", xnl[10].InnerText);
                packageReqHandler.setParameter("time_end", xnl[12].InnerText);
                packageReqHandler.setParameter("total_fee", xnl[13].InnerText);
                packageReqHandler.setParameter("trade_type", "JSAPI");
                packageReqHandler.setParameter("transaction_id", xnl[15].InnerText);
                string sign = packageReqHandler.CreateMd5Sign("key", WxConfig.appkey);
                if (sign == xnl[11].InnerText)
                {
                    if (xnl[9].InnerText == "SUCCESS" && xnl[10].InnerText == "SUCCESS")
                    {
                        string out_trade_no = xnl[8].InnerText;
                        double money = Convert.ToDouble(Convert.ToInt32(xnl[13].InnerText)) / 100;
                        DBAPI.SendDataToAPI("", "");
                        string xmlStr = "<xml><return_code><![CDATA[SUCCESS]]></result_code></xml>";
                        Response.ContentType = "text/xml";
                        Response.Clear();
                        Response.Write(xmlStr);
                        Response.End();
                    }
                }
            }
        }
    }
}